---
title: 'SyntaxError: missing variable name'
slug: Web/JavaScript/Reference/Errors/No_variable_name
tags:
  - Error
  - Errors
  - JavaScript
  - SyntaxError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "missing variable name" occurs way too often as naming things is so hard. Or maybe a comma is wrong. Check for typos!</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox notranslate">SyntaxError: missing variable name (Firefox)
SyntaxError: Unexpected token = (Chrome)</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("SyntaxError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>A variable is missing a name. This is likely due to a syntax error in your code. Probably a comma is wrong somewhere or you struggled with coming up with a name. Totally understandable! Naming things is so hard.</p>

<ul>
 <li>Check to ensure the previous lines / declaration does not end with a comma instead of a semi-colon.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Missing_a_variable_name">Missing a variable name</h3>

<pre class="brush: js example-bad notranslate">var = "foo";
</pre>

<p>It's tough coming up with good variable names. We all have been there.</p>

<pre class="brush: js example-good notranslate">var ohGodWhy = "foo";</pre>

<h3 id="Reserved_keywords_cant_be_variable_names">Reserved keywords can't be variable names</h3>

<p>There are a few variable names that are <a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#Keywords">reserved keywords</a>. You can't use these. Sorry :(</p>

<pre class="brush: js example-bad notranslate">var debugger = "whoop";
// SyntaxError: missing variable name
</pre>

<h3 id="Declaring_multiple_variables">Declaring multiple variables</h3>

<p>Pay special attention to commas when declaring multiple variables. Is there an excess comma? Did you accidentally add commas instead of semicolons?</p>

<pre class="brush: js example-bad notranslate">var x, y = "foo",
var x, = "foo"

var first = document.getElementById('one'),
var second = document.getElementById('two'),

// SyntaxError: missing variable name
</pre>

<p>The fixed version:</p>

<pre class="brush: js example-good notranslate">var x, y = "foo";
var x = "foo";

var first = document.getElementById('one');
var second = document.getElementById('two');</pre>

<h3 id="Arrays">Arrays</h3>

<p>{{jsxref("Array")}} literals in JavaScript need square brackets around the values. This won't work:</p>

<pre class="brush: js example-bad notranslate">var arr = 1,2,3,4,5;
// SyntaxError: missing variable name
</pre>

<p>This would be correct:</p>

<pre class="brush: js example-good notranslate">var arr = [1,2,3,4,5];</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="http://wiki.c2.com/?GoodVariableNames">Good variable names</a></li>
 <li>{{jsxref("Statements/var", "var")}}</li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Grammar_and_types#Declarations">Variable declarations in the JavaScript Guide</a></li>
</ul>
